import os
import sys

from Models.Interpreter.Error import Error
from ServiceInitializer import ServiceInitializer


class Main:

    def __init__(self) -> None:
        self.__services = ServiceInitializer()
        self.__utils = self.__services.utils
        self.__repo = self.__services.repo
        self.__interpreter = self.__services.interpreter

    def console(self) -> None:
        print('sh-edraft.de basic language interpreter:')
        cont = True
        while cont:
            cont = self.__interpreter.interpret(input('> '))

    def files(self, file: str) -> None:
        if os.path.isfile(file):
            f = open(file, 'r', encoding='utf-8').readlines()
            for i in range(0, len(f)):
                self.__interpreter.interpret(i+1, f[i])
        else:
            self.__utils.error(Error(1.1))


if __name__ == '__main__':
    main = Main()
    print(sys.argv)
    if len(sys.argv) == 2:
        main.files(sys.argv[1])
    else:
        main.console()
