class Error:

    def __init__(self, code: float, msg: str = ''):
        self.code = code

        self.__msgs = {
            # Interpreter:
            1.0: 'Start failed',
            1.1: 'File not found',

            # Runtime:
            2.0: 'Unknown keyword',
            2.1: 'Unknown type',
            2.2: 'Unknown variable',
            2.3: 'Unknown function',
            2.4: 'Unknown class',
            2.5: 'Unknown library',

            # Parser:
            3.0: 'Lib in lib',
            3.1: 'Lib in class',
            3.2: 'Lib in func',
            3.3: 'Class in class',
            3.4: 'Class in func',
            3.5: 'Func in lib',
            3.6: 'Func in func',
            3.7: 'Expected: type',
            3.8: 'Access error: no export',
            3.9: 'Expression error',
            3.10: 'Unexpected end of line',
            3.11: 'Unexpected {}',       # other types
        }

        self.msg = self.__msgs[code].format(msg)
